VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSocket_Client"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Event Connect()
Public Event Closed()
Public Event SendComplete()
Public Event DataArrival(BinData As String, RemoteHostIP As String)
Public Event Error(Error As Long, Description As String)

Private WithEvents myWinsock As WinsockClient_Form
Attribute myWinsock.VB_VarHelpID = -1

Private myHost As String
Private myPort As Long
Private myLastPacketData As String

Public Property Get LocalIP() As String
    LocalIP = myWinsock.myWinsock.LocalIP
End Property

Public Property Get SocketHandle&()
    SocketHandle = myWinsock.myWinsock.SocketHandle
End Property

Public Property Get State() As sockType
    State = myWinsock.GetState()
End Property

Public Property Get LocalPort&()
    LocalPort = myWinsock.myWinsock.LocalPort
End Property

Public Property Let LocalPort(theValue&)
    myWinsock.myWinsock.LocalPort = theValue
End Property

Public Property Get RemoteHost$()
    RemoteHost = myWinsock.myWinsock.RemoteHost
End Property

Public Property Get RemotePort&()
    RemotePort = myWinsock.myWinsock.RemotePort
End Property

Public Sub Connect(ByVal Host As String, ByVal Port As Long)
    myHost = Host
    myPort = Port
    myWinsock.myWinsock.Connect myHost, myPort
End Sub

Public Sub ReConnect()
    myWinsock.myWinsock.Connect myHost, myPort
End Sub

Public Function SendData(Data As Variant) As Long
    myLastPacketData = CStr(Data)
    myWinsock.myWinsock.SendData myLastPacketData
End Function

Public Sub ReSendData()
    myWinsock.myWinsock.SendData myLastPacketData
End Sub

Public Sub Disconnect()
    myWinsock.myWinsock.Close
End Sub

Private Sub Class_Initialize()
    NewInstanz "CSocket_Client"
    Set myWinsock = New WinsockClient_Form
    myWinsock.SetClass Me
End Sub

Private Sub Class_Terminate()
    UnloadInstanz "CSocket_Client"
End Sub

Public Sub Cancel()
    myWinsock.Cancel
    Unload myWinsock
    Set myWinsock = Nothing
End Sub

Private Sub myWinsock_Closed()
    RaiseEvent Closed
End Sub

Private Sub myWinsock_Connect()
    RaiseEvent Connect
End Sub

Private Sub myWinsock_DataArrival(BinData As String, RemoteHostIP As String)
    RaiseEvent DataArrival(BinData, RemoteHostIP)
End Sub

Private Sub myWinsock_Error(Error As Long, Description As String)
    RaiseEvent Error(Error, Description)
End Sub

Private Sub myWinsock_SendComplete()
    RaiseEvent SendComplete
End Sub

Public Property Let Protocol(theType As ProtocolConstants)
    myWinsock.myWinsock.Protocol = theType
End Property

Public Property Get Protocol() As ProtocolConstants
    Protocol = myWinsock.myWinsock.Protocol
End Property

Public Property Get LastPacketData() As String
    LastPacketData = myLastPacketData
End Property
