Attribute VB_Name = "MainCode"
'   AZChat
'   ======
'
'programmiert von (c) Albert Zeyer
Option Explicit
Global Const ProgrammName As String = "MailForwarder"

Global Unloading As Boolean
Global ProgramIsRunning As Boolean

Sub Main()
 Unloading = False
 ProgramIsRunning = True
  
 If App.PrevInstance Then 'Programm luft bereits?
  End
 End If
 
 init_Debug
 init_TimerModul
 DefineConstants
 CheckCommandParameter
  
 Log "Programmstart"
 If GetOption(StartCounterFile, "0") = "0" Then
  Log "first start"
  SetOption StartCounterFile, "1"
 Else
  SetOption StartCounterFile, LTrim$(RTrim$(Str$(Val(GetOption(StartCounterFile)) + 1)))
 End If
 
 Log "LoadStandard"
 LoadStandard
 
 Log "ready to show me"
 ShowMe
 
 Log "Start-Prozess ready"
End Sub

Private Sub CheckCommandParameter()
 ReDim Commands(1) As String
 Dim Temp As String
 Temp = LTrim$(RTrim$(Command$))
 Dim X As Long
 Dim InA As Boolean 'in Anfhrungsstrichen (")
 InA = False
 For X = 1 To Len(Temp)
  Select Case Mid$(Temp, X, 1)
   Case Chr$(34) '"
    InA = Not InA
   Case " "
    If InA Then
     Commands(UBound(Commands)) = Commands(UBound(Commands)) _
                                + Mid$(Temp, X, 1)
    Else
     If Commands(UBound(Commands)) <> "" Then
      ReDim Preserve Commands(UBound(Commands) + 1) As String
     End If
    End If
   Case Else
    Commands(UBound(Commands)) = Commands(UBound(Commands)) _
                               + Mid$(Temp, X, 1)
  End Select
 Next
 If Commands(UBound(Commands)) = "" Then
  ReDim Preserve Commands(UBound(Commands) - 1) As String
 End If

 For X = 1 To UBound(Commands)
  Select Case Left$(Commands(X), 1)
   Case "\", "-", "/"
    Commands(X) = LTrim$(RTrim$(Right$(Commands(X), Len(Commands(X)) - 1)))
  End Select
  If AZLeftGleich(UCase$(Commands(X)), "DEBUGFILE") Then
   enable_ProzessDebugFile_Engine
  ElseIf AZLeftGleich(UCase$(Commands(X)), "DEBUG") Then
   show_DebugForm
  ElseIf AZLeftGleich(UCase$(Commands(X)), "LOG") Then
   set_CreateLogState Val(Right$(Commands(X), Len(Commands(X)) - 3))
  ElseIf AZLeftGleich(UCase$(Commands(X)), "PROZESSINFO") Then
   enable_ProzessInfo
  ElseIf AZLeftGleich(UCase$(Commands(X)), "BACKGROUND") Then
   StartMinimiert = True
  End If
 Next
End Sub

Private Sub LoadStandard()
 Log "loading MainForm ..."
 Load MainForm
End Sub

Private Sub ShowMe()
 'Test_PopClient.Show
 MainForm.Show
 If StartMinimiert Then MainForm.WindowState = 1 'minimiert
End Sub

Public Sub ExitProg()
 Log "Unloading now..."
 Unloading = True
 Dim F As Form
 For Each F In Forms
  'If Not TypeOf F Is DebugForm Then
   Unload F
  'End If
 Next
 Log "Exit"
End Sub

Public Sub RestartProg()
 ExitProg
 Log "Restart"
 Shell Verz + App.EXEName + ".exe " + Command$, vbNormalFocus
End Sub

