Attribute VB_Name = "WinMessages_Modul"
Option Explicit

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
 (ByVal lpPrevWndFunc As Long, _
  ByVal hwnd As Long, ByVal Msg As Long, _
  ByVal wParam As Long, ByVal lParam As Long) As Long

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
 (ByVal hwnd As Long, _
  ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_WNDPROC = -4
Public Const WM_MOVE = 3

Private OldWndProcs As New Collection
Private HookedForms As New Collection

Public Sub HookForm(TheObject As WinMessages)
    Dim TheKey$, OldWndProc As Long
    
    TheKey$ = CStr(TheObject.hwnd)
    HookedForms.Add TheObject, TheKey$
        
    OldWndProc = SetWindowLong(TheObject.hwnd, GWL_WNDPROC, _
            AddressOf newWndProc)
        
    OldWndProcs.Add OldWndProc, TheKey$
End Sub

Public Sub UnhookForm(TheObject As WinMessages)
    Dim TheKey$, OldWndProc As Long, TheHWnd&, ResL&
    
    TheKey$ = CStr(TheObject.hwnd)
    OldWndProc = OldWndProcs.Item(TheKey$)
        
    If OldWndProc = 0 Then Exit Sub
        
    TheHWnd& = HookedForms.Item(TheKey$).hwnd
    ResL& = SetWindowLong(TheHWnd&, GWL_WNDPROC, OldWndProc)
        
    HookedForms.Remove TheKey$
    OldWndProcs.Remove TheKey$
End Sub

Private Function newWndProc( _
                   ByVal hwnd As Long, ByVal uMsg As Long, _
                   ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim TheKey$, OldWndProc As Long

    TheKey$ = CStr(hwnd)
    OldWndProc = OldWndProcs.Item(TheKey$)
        
    newWndProc = CallWindowProc(OldWndProc, hwnd, uMsg, wParam, lParam)
    
    On Error GoTo IgnoreIt
    HookedForms.Item(TheKey$).RaiseEvent_WinMessage hwnd, uMsg, wParam, lParam
IgnoreIt:
    Exit Function
End Function

