VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form WinsockClient_Form 
   ClientHeight    =   2370
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3255
   LinkTopic       =   "Form1"
   ScaleHeight     =   2370
   ScaleWidth      =   3255
   StartUpPosition =   3  'Windows-Standard
   Begin MSWinsockLib.Winsock myWinsock 
      Left            =   120
      Top             =   120
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
End
Attribute VB_Name = "WinsockClient_Form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Event Connect()
Public Event Closed()
Public Event SendComplete()
Public Event DataArrival(BinData As String, RemoteHostIP As String)
Public Event Error(Error As Long, Description As String)

Private myClass As CSocket_Client

Private Sub Form_Load()
    NewInstanz "WinsockClient_Form"
End Sub

Private Sub Form_Unload(Cancel As Integer)
    UnloadInstanz "WinsockClient_Form"
End Sub

Public Sub SetClass(TheClass As CSocket_Client)
    Set myClass = TheClass
End Sub

Private Sub myWinsock_Close()
    myWinsock.Close
    RaiseEvent Closed
End Sub

Private Sub myWinsock_Connect()
    RaiseEvent Connect
End Sub

Private Sub myWinsock_DataArrival(ByVal bytesTotal As Long)
    Dim Temp As String
    Temp = Space$(bytesTotal)
    On Error GoTo Fehler
    myWinsock.GetData Temp
    On Error GoTo 0
    RaiseEvent DataArrival(Temp, myWinsock.RemoteHostIP)
    Exit Sub
    
Fehler:
    Dim ErrNr As Long
    Dim ErrDesc As String
    ErrNr = Err.Number
    ErrDesc = Err.Description
    Resume Fehlerbehandlung
    
Fehlerbehandlung:
    On Error GoTo 0
    myWinsock_Error ErrNr, ErrDesc, 0, "", "", 0, False
    Exit Sub
End Sub

Private Sub myWinsock_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    myWinsock_Close
    RaiseEvent Error(CLng(Number), Description)
End Sub

Private Sub myWinsock_SendComplete()
    RaiseEvent SendComplete
End Sub

Public Function GetState() As sockType
    Select Case myWinsock.State
        Case sckClosed
            GetState = sockClosed
        Case sckOpen
            GetState = sockClosed
        Case sckListening
            GetState = sockListening
        Case sckConnectionPending
            GetState = sockConnecting
        Case sckResolvingHost
            GetState = sockConnecting
        Case sckHostResolved
            GetState = sockConnecting
        Case sckConnecting
            GetState = sockConnecting
        Case sckConnected
            GetState = sockConnected
        Case sckClosing
            GetState = sockClosed
        Case sckError
            GetState = sockClosed
    End Select
End Function

Public Sub Cancel()
    myWinsock.Close
    Set myClass = Nothing
End Sub

